/*
 * Error_Check.c
 *
 *  Created on: Jun 16, 2022
 *      Author: max
 */

#include "Error_Check.h"

ErrorFlags CheckErrorFlags() {
  ErrorFlags errors = {0};
  errors.IMD_ERROR = !HAL_GPIO_ReadPin(IMD_Error_GPIO_Port, IMD_Error_Pin);
  errors.IMD_ERROR_LED =
      HAL_GPIO_ReadPin(IMD_Error_LED_GPIO_Port, IMD_Error_LED_Pin);
  errors.AMS_ERROR_LED =
      HAL_GPIO_ReadPin(AMS_ERROR_GPIO_Port, AMS_Error_LED_Pin);

  errors.TS_no_voltage_error =
      HAL_GPIO_ReadPin(Volt_Error_CPU_GPIO_Port, Volt_Error_CPU_Pin);
  errors.positive_AIR_or_PC_error = HAL_GPIO_ReadPin(
      Positive_Side_Error_CPU_GPIO_Port, Positive_Side_Error_CPU_Pin);
  errors.negative_AIR_error =
      HAL_GPIO_ReadPin(Neg_Side_Error_CPU_GPIO_Port, Neg_Side_Error_CPU_Pin);

  errors.HV_inactive =
      HAL_GPIO_ReadPin(HV_Inactive_CPU_GPIO_Port, HV_Inactive_CPU_Pin);
  errors.negative_AIR_open =
      HAL_GPIO_ReadPin(Neg_AIR_Open_CPU_GPIO_Port, Neg_AIR_Open_CPU_Pin);
  errors.positive_AIR_and_PC_open =
      HAL_GPIO_ReadPin(High_Side_Open_CPU_GPIO_Port, High_Side_Open_CPU_Pin);
  return errors;
}
